Page MenuHomePhabricator

[Tracking] Trying to saving a page when Mediawiki is on readonly mode shows no message or error
Closed, ResolvedPublic

Description

During a read-only passage of Wikipedia today (T194939, https://gerrit.wikimedia.org/r/#/c/435755/), I wanted to try to save a page via the mobile site.
After opening the editor, makes a small change in the code, clicking the Save button displays no messages, no errors. Interface just tries to save the page, but it can't. After a few seconds, the button becomes clickable again. The user can click several times on the button infinitely, the site tries again.
It would simply appear that the software does not take this case into account.
This is quite problematic since the mediawiki desktop website displays an error message chosen by the administrator. Mobile users do not see this information. Nothing indicates that it is temporarily normal that the site is not editable.


Analysis (@Jdrewniak)

From my analysis, I think there are 4 distinct bugs here:

  1. Prior to editing, there is no indication the site is in read-only mode.
  2. In mobile VE, saving fails with a "<apierror-readonly>" message (correctly), but the actual message text does not show up. (note: this could be a local error, should verify on another machine).
  3. In mobile source editor after the save fails, a toast is presented with a generic error message, but the toast is not visible until you scroll down, and the toast appears "underneath" the article content. The error message should probably display the "apierror-readonly" message EditorOverlay.js#L285
  4. In the EditorGateway the failed save falls through as a generic "http" error. The actual nature of the error is not considered when presenting the error message. EditorGateway.js#L233

Acceptance criteria

  • All subtasks resolved

Event Timeline

Restricted Application added a subscriber: Aklapper. · View Herald TranscriptMay 29 2018, 8:13 PM
ovasileva triaged this task as Medium priority.May 30 2018, 3:45 PM
Jdrewniak claimed this task.Jun 4 2018, 8:58 AM
Jdrewniak updated the task description. (Show Details)
Jdrewniak added a subscriber: Jdrewniak.
Jdrewniak updated the task description. (Show Details)Jun 4 2018, 9:06 AM

@Jdrewniak LGTM.

In mobile VE, saving fails with a "<apierror-readonly>" message (correctly), but the actual message text does not show up. (note: this could be a local error, should verify on another machine).

I think this is how VE works, this task should be tagged VE as they'll be better equipped to address it. The other 3 feel like they could be easily resolved in one task. Any reason to split this into 4 tasks or could we just do it (seems straightforward enough to me for one task rather than complicating QA)?

Prior to editing, there is no indication the site is in read-only mode.

Note, I'd assume this would mean showing the edit locked icon - if so, this prevents all of the other 3 errors from occurring (with the slight edge case of an edit that's in progress), so it seems addressing that is the highest priority.

Jdlrobson renamed this task from Trying to saving a page when Mediawiki is on readonly mode shows no message or error to [Tracking] Trying to saving a page when Mediawiki is on readonly mode shows no message or error.Jun 15 2018, 10:20 PM
Jdlrobson updated the task description. (Show Details)
Jdlrobson moved this task from Needs Prioritization to Epics/Goals on the Readers-Web-Backlog board.

Subtasks created!

Vvjjkkii renamed this task from [Tracking] Trying to saving a page when Mediawiki is on readonly mode shows no message or error to 80baaaaaaa.Jul 1 2018, 1:07 AM
Vvjjkkii removed Jdrewniak as the assignee of this task.
Vvjjkkii raised the priority of this task from Medium to High.
Vvjjkkii updated the task description. (Show Details)
Vvjjkkii removed a subscriber: Aklapper.
CommunityTechBot renamed this task from 80baaaaaaa to [Tracking] Trying to saving a page when Mediawiki is on readonly mode shows no message or error.Jul 2 2018, 2:42 AM
CommunityTechBot assigned this task to Jdrewniak.
CommunityTechBot lowered the priority of this task from High to Medium.
CommunityTechBot updated the task description. (Show Details)
CommunityTechBot added a subscriber: Aklapper.
Framawiki updated the task description. (Show Details)Jul 4 2018, 4:59 PM

Acceptance criteria: All subtasks resolved

@Jdrewniak: All subtasks are resolved. Can this be closed?

[not a Tracking-Neverending bug per definition; maybe Epic or such was meant?]

Jdlrobson closed this task as Resolved.Nov 26 2018, 4:29 PM

Lgtm